# Test execution parameters

*Test execution reports* describe which tests within your test suite have been run during a build.

This differs from *test coverage reports*, which describe the percentage of your code that has been tested by your test suite during a build. For details, see [overview](https://docs.sonarsource.com/sonarqube-server/10.7/analyzing-source-code/test-coverage/overview "mention").

Test execution reports are not generated by SonarQube itself. Much like tests coverage reports, test execution reports must be generated by an external tool and then imported into SonarQube by specifying a parameter telling the scanner where to look for the report. The data is then displayed in your SonarQube analysis.

Below, you will find language- and tool-specific analysis parameters for importing test execution reports.

For information on analysis parameters in general, see [analysis-parameters](https://docs.sonarsource.com/sonarqube-server/10.7/analyzing-source-code/analysis-parameters "mention").

Unless otherwise specified, these properties require values that are relative to the project root. Some properties support the following wildcards in paths. The remarks for properties that support wildcards will mention this fact. If wildcards are not noted for a given property, then they are not supported for that property.

|            |                           |
| ---------- | ------------------------- |
| **Symbol** | **Meaning**               |
| `?`        | a single character        |
| `*`        | any number of characters  |
| `**`       | any number of directories |

## Branches only <a href="#branches-only" id="branches-only"></a>

*SonarQube only supports test execution reports for the branches of a project (including the main branch), not for pull requests.* This differs from the case with test coverage reports, where pull requests are supported.

## All languages <a href="#all-languages" id="all-languages"></a>

### sonar.testExecutionReportPaths <a href="#sonartestexecutionreportpaths" id="sonartestexecutionreportpaths"></a>

Comma-delimited list of paths to execution reports in the [generic-test-data](https://docs.sonarsource.com/sonarqube-server/10.7/analyzing-source-code/test-coverage/generic-test-data "mention") format.

## C/C++/Objective-C <a href="#cfamily" id="cfamily"></a>

### sonar.cfamily.cppunit.reportsPath <a href="#sonarcfamilycppunitreportspath" id="sonarcfamilycppunitreportspath"></a>

Path to the directory holding the [CPPUnit](https://sourceforge.net/projects/cppunit/) reports. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

## C# <a href="#csharp" id="csharp"></a>

### sonar.cs.vstest.reportsPaths <a href="#sonarcsvstestreportspaths" id="sonarcsvstestreportspaths"></a>

Paths to VSTest reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

### sonar.cs.nunit.reportsPaths <a href="#sonarcsnunitreportspaths" id="sonarcsnunitreportspaths"></a>

Paths to NUnit execution reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

### sonar.cs.xunit.reportsPaths <a href="#sonarcsxunitreportspaths" id="sonarcsxunitreportspaths"></a>

Paths to xUnit execution reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

## Go <a href="#go" id="go"></a>

### sonar.go.tests.reportPaths <a href="#sonargotestsreportpaths" id="sonargotestsreportpaths"></a>

Comma-delimited list of paths to unit test report files. Paths may be absolute or relative to the project root.

## Java <a href="#java" id="java"></a>

### sonar.junit.reportPaths <a href="#sonarjunitreportpaths" id="sonarjunitreportpaths"></a>

Comma-delimited list of paths to Surefire XML-format reports.

## PHP <a href="#php" id="php"></a>

### sonar.php.tests.reportPath <a href="#sonarphptestsreportpath" id="sonarphptestsreportpath"></a>

Path to the PHPUnit unit test execution report file. The path may be absolute or relative to the project root.

## Python <a href="#python" id="python"></a>

### sonar.python.xunit.reportPath <a href="#sonarpythonxunitreportpath" id="sonarpythonxunitreportpath"></a>

Path to unit test execution report. Leave unset to use the default (`xunit-reports/xunit-result-*.xml`). Path wildcards (see above) are supported. If any paths in the report are invalid, set `sonar.python.xunit.skipDetails=true` to collect only project-level details.

## VB.NET <a href="#vb-dotnet" id="vb-dotnet"></a>

### sonar.vbnet.vstest.reportsPaths <a href="#sonarvbnetvstestreportspaths" id="sonarvbnetvstestreportspaths"></a>

Paths to VSTest execution reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

### sonar.vbnet.nunit.reportsPaths <a href="#sonarvbnetnunitreportspaths" id="sonarvbnetnunitreportspaths"></a>

Paths to NUnit execution reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.

### sonar.vbnet.xunit.reportsPaths <a href="#sonarvbnetxunitreportspaths" id="sonarvbnetxunitreportspaths"></a>

Paths to xUnit execution reports. Multiple paths may be comma-delimited or included via wildcards. Note that while measures such as the number of tests are displayed at the project level, no drill-down is available.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sonarsource.com/sonarqube-server/10.7/analyzing-source-code/test-coverage/test-execution-parameters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
